//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	delib_intern.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// --------------------------------------------------------

#define MAX_NO_OF_SAME_MODULES 16

// --------------------------------------------------------

#ifndef __linux__
	#define USE_FTDI_DUAL 1
	#define USE_FTDI 1
	#define USE_SER 1
	#define USE_ETH 1
	#define USE_FTDI_SER 1
#endif

// --------------------------------------------------------
#define delib_id 0x12345678

#define DapiModuleID_Device 1
#define DapiModuleID_DeviceProg 0

// --------------------------------------------------------
typedef struct xxDAPI_HANDLE
{
	ULONG id;
	FT_HANDLE ftHandle;
	ULONG TCPHandle;
	ULONG TCPHandle_tx;
	ULONG moduleID;
	ULONG moduleNr;
	ULONG SubDevice;
	ULONG jobID;
	ULONG BusType;
	ULONG ComPort;
	ULONG RS485_ModuleNr;
	UCHAR ProgramName[12];
	ULONG addr_dapi_module_params;
	ULONG retry;	// usb, ser
	ULONG timeout;	// eth
} DAPI_HANDLE;

// --------------------------------------------------------
typedef struct xxDAPI_MODULE_PARAMS
{
	char fw_version[4];
	ULONG hw_interface1;
	ULONG sw_feature1;
	ULONG anz_di;
	ULONG anz_di_counter;
	ULONG anz_di_ff;
	ULONG anz_do;
	ULONG anz_ai;
	ULONG anz_ao;
	ULONG anz_stepper;
	ULONG anz_temp;
	ULONG anz_counterin48;
	ULONG anz_counterout32;
	ULONG anz_output_pwm;
	ULONG anz_dx;
	ULONG sw_class;
	ULONG hw_group;
} DAPI_MODULE_PARAMS;

// --------------------------------------------------------
#define cmd_ping		0x12
#define cmd_send8byte	0x23
#define cmd_get8byte	0x34
#define cmd_sendnbyte	0x45
#define cmd_getnbyte	0x56

// --------------------------------------------------------
#define bus_FTDI_DUAL	1
#define bus_SeriellCOM	2
#define bus_SeriellFTDI	3
#define bus_ETH			4
#define bus_FTDI_SINGLE	5
#define bus_ETH_INTERN	6

#define DAPI_INTERFACE_UNDEFINED		0
#define DAPI_INTERFACE_CAN				1
#define DAPI_INTERFACE_USB				2
#define DAPI_INTERFACE_ETH				3
#define DAPI_INTERFACE_SER				4

// --------------------------------------------------------
#ifdef __linux__
	#define DAPI_SPECIAL_CMD_MODULE_CONFIG					0xf0000001
	#define DAPI_SPECIAL_MODULECFG_MODULE_ID_SET			1
#endif
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
