//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	deditec_msgq_srv_threat.c
//	project: DEDITEC library
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

#include <stdio.h>
#include <string.h>
#include "deditec_log.h"

#include "pthread.h"



// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// initialisierung globaler variablen

bool m_fMSGQThreadIsRunning = FALSE;
bool fMSGQQuit;
pthread_t m_hMSGQThread;

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// prototypen

void MSGQThread(void *pParam);

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// Message Queue Thread main

void MSGQThread(void *pParam)
{
	int serverid;

	fMSGQQuit = FALSE;

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// erstellt message queue

	
	if (dt_msgq_create_all_for_server(MSGQ_SERVER_ID, &serverid) != RETURN_OK)
	{
		log_write("failed to create global id storage for MSGQ Thread", 1);

		pthread_exit((void *) 0);
	}

	log_write("MSGQ Thread initiated successfully", 1);

	m_fMSGQThreadIsRunning = TRUE;

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------

	// infinite loop zum holen von Messages aus dem Queue. kann mit fMSGQQuit = TRUE; unterbrochen werden.
	while(fMSGQQuit == FALSE)
	{
		dt_msgq_server_check(serverid, DT_MSGQ_SERVER_CHECK_WAIT);
	}

	// ----------------------------------------------------------------------------
	// ----------------------------------------------------------------------------
	// beende thread da fMSGQQuit == TRUE;

	dt_msgq_delete_all(MSGQ_SERVER_ID, serverid);

	m_fMSGQThreadIsRunning = FALSE;

	log_write("MSGQ Thread closing", 1);

	pthread_exit((void *) 0);
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long msgq_thread_create(void)
{
	if(pthread_create(&m_hMSGQThread, NULL, (void *) MSGQThread, "DispCtlr") != 0)
	{
		return RETURN_ERROR;
	}
	else
	{
		return RETURN_OK;
	}
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

bool msgq_thread_is_running(void)
{
	return m_fMSGQThreadIsRunning;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

void msgq_thread_shut_down(void)
{
	fMSGQQuit = TRUE;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
