//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	deditec_buff_utils.cpp
//	project: delib
//
//
//  (c) DEDITEC GmbH, 2013
//  web: http://www.deditec.de/
//  mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ------------------------------------
// ------------------------------------
// History
// ------------------------------------
// ------------------------------------
//
// DT	13.11.2013	Start DEDITEC-History
// 
// ------------------------------------
// ------------------------------------
// Functions
// ------------------------------------
// ------------------------------------
//
// Buffer
// ------------------------------------
// buffer_line_copy
// buffcat_n - noch nicht implementiert
// buffcpy_n
// buffcmp_n
// memset_n
//
// ------------------------------------
// ------------------------------------
// Includes
// ------------------------------------
// ------------------------------------

#include <stdio.h>
#include <stdlib.h>

#include "deditec_convert_functions.h"
#include "../embedded/dt_var_defines.h"

// ------------------------------------
// ------------------------------------
// Defines
// ------------------------------------
// ------------------------------------

#define ERROR 100
#define LINE_LENGTH 1000

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long buffer_line_copy(unsigned char *dest_buffer, unsigned char * source_buffer)
{
	unsigned long counter;

	counter = 0;

	while ((*(source_buffer + counter) != 10) && ((*(source_buffer + counter) != 0)))
	{
		*(dest_buffer + counter) = *(source_buffer + counter);
		++counter;
	}
	
	if (*(source_buffer + counter) == 0x0a)
	{
		*(dest_buffer + counter) = 0x0a;
		++counter;
		*(dest_buffer + counter) = 0x00;
	}
	else
	{
		*(dest_buffer + counter) = 0x00;
	}

	return counter;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long buffcpy_n( unsigned char * dest_buffer,   unsigned long dest_buffer_size,
                         unsigned char * source_buffer, unsigned long amount_of_bytes)
{
	unsigned long pos_source_buffer;
	unsigned long amount_copied_bytes;

	pos_source_buffer = 0;
	amount_copied_bytes = 0;

	if (dest_buffer_size < amount_of_bytes) return -1;

	while (pos_source_buffer < amount_of_bytes)
	{
		*(dest_buffer + pos_source_buffer) = *(source_buffer + pos_source_buffer);
		pos_source_buffer++;
		amount_copied_bytes++;
	}

	return 0;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long buffcmp_n (unsigned char *needle, unsigned long needle_length, unsigned char *heystack, unsigned long heystack_length)
{
	unsigned long i;

	if (needle_length != heystack_length)
		return 1;
	
	for (i = 0; i < needle_length; i++)
	{
		if (needle[i] != heystack[i])
		{
			return 1;
		}
	}
	
	return 0;
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

unsigned long memset_n(unsigned char *ptr, unsigned long ptr_size, unsigned long value, unsigned long amount_bytes)
{
	unsigned long pos;
	
	for (pos=0; pos!=amount_bytes; pos++)
	{
		if (pos<ptr_size)
		{
			*(ptr + pos) = (unsigned char) value;
		}
		else
		{
			// ausserhalb des speicherbereichs
			return RETURN_ERROR;
		}	
	}
	
	return RETURN_OK;	
}

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
