//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//
//
//
//	dt_embedded_parameter.h
//	project: delib
//
//
//	(c) DEDITEC GmbH, 2013
//	web: http://www.deditec.de/
//	mail: vertrieb@deditec.de
//
// 
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************
//***********************************************************************************

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Filenames
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define ACTUALIZE_ETH0_AND_AUTOSTARTUP						"/deditec/bin/ip_address_set_from_parameter_io > /deditec_logs/output_from_ip_address_set_from_parameter_io"
#define ACTUALIZE_FIRMWARE_DEFAULT							"/firmware/arm9_upd_fw_default.sh > /deditec_logs/output_from_firmware_default"
#define ACTUALIZE_FIRMWARE_UPDATE							"/firmware/arm9_upd_fw_update.sh > //deditec_logs/output_from_firmware_update"
#define ACTUALIZE_FIRMWARE_CUSTOM1_UPDATE					"/firmware/arm9_upd_custom1_fw_update.sh > //deditec_logs/output_from_custom1_firmware_update"

// ------------------------------------
#define DIRNAME_ROOT_DIR_HTML								"/deditec/www/"          // don't forget to add a '/' at end

// ------------------------------------
#define FILENAME_DEFAULT_OPEN_HTML							"index.html"
#define FILENAME_PARAMETER_IO								"/deditec/deditec.cfg"
#define FILENAME_USRMGR_RIGHTS								"/deditec/deditec_user_rights.cfg"
#define FILENAME_USRMGR_PWDS								"/deditec/deditec_user_pwds.cfg"
#define FILENAME_SCHEDULER									"/deditec/deditec_scheduler.cfg"
#define FILENAME_LOGFILE									"/deditec_logs/deditec.log"
#define FILENAME_LOG_WEBCMD_POST							"/deditec_logs/webcmd_post.log"
#define FILENAME_LOG_WEBCMD_POST_EXTRACT					"/deditec_logs/webcmd_post_extract.log"
#define FILENAME_LOG_WEBCMD_SEND							"/deditec_logs/webcmd_send_to_browser.log"

#define FILENAME_LOG_WEBLOGIN_POST							"/deditec_logs/weblogin_post.log"
#define FILENAME_LOG_WEBLOGIN_POST_EXTRACT					"/deditec_logs/weblogin_post_extract.log"
#define FILENAME_LOG_WEBLOGIN_SEND							"/deditec_logs/weblogin_send_to_browser.log"

#define FILENAME_LOG_WEBUPD_POST							"/deditec_logs/webupd_post.log"
#define FILENAME_LOG_WEBUPD_POST_EXTRACT					"/deditec_logs/webupd_post_extract.log"
#define FILENAME_LOG_WEBUPD_SEND							"/deditec_logs/webupd_send_to_browser.log"

#define FILENAME_FIRMWARE_UPDATE_FILE						"/firmware/update/UPDATE_FIRMWARE.tar"
#define FILENAME_FIRMWARE_UPDATE_FILE_PC					"ro_cpu_eth_fw.dfw"
#define FILENAME_FIRMWARE_UPDATE_CUSTOM1_FILE_PC			"RO-ETH_CUSTOM1.tar"

#define FILE_LOG_MAX_SIZE									1024*1024


// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// TCP-IP und BC Parameter
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

// ------------------------------------
#define DEDITEC_EMBEDDED_BC_PORT							9912
#define DEDITEC_DEFAULT_TCP_PORT_NO							9912

// ------------------------------------
// TCP TX and RX ID's
#define DEDITEC_TCP_PACKET_ID_0								0x63
#define DEDITEC_TCP_PACKET_ID_1								0x9a
#define DEDITEC_TCP_PACKET_ID_2_CMD_RO_1					0x01
#define DEDITEC_TCP_PACKET_ID_2_CMD_RO_BIG					0x02
#define DEDITEC_TCP_PACKET_ID_2_CMD_SEND_FILE				0x03
#define DEDITEC_TCP_PACKET_ID_2_CMD_SPECIAL					0x04


#define DEDITEC_TCP_PACKET_ID_2_ANSWER_RO_1					0x81
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_RO_BIG				0x82
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_CMD_SEND_FILE		0x83
#define DEDITEC_TCP_PACKET_ID_2_ANSWER_CMD_SPECIAL			0x84

// ------------------------------------
#define CONNECTION_TIMEOUT_TO_CLIENT 						5
// timeout value in seconds; server closes connection to client after x seconds

// ------------------------------------
#define DEDITEC_TCP_START_ID_FOR_MULTIPLE_BYTE_DATA			35

// ------------------------------------
// Broadcast TX and RX ID's

#define DEDITEC_BC_PACKET_TX_ID_0 							0x12
#define DEDITEC_BC_PACKET_TX_ID_1 							0x47
#define DEDITEC_BC_PACKET_TX_ID_2 							0x22
#define DEDITEC_BC_PACKET_TX_ID_3 							0x01

#define DEDITEC_BC_PACKET_RX_ID_0 							0x13
#define DEDITEC_BC_PACKET_RX_ID_1 							0x47
#define DEDITEC_BC_PACKET_RX_ID_2 							0x22
#define DEDITEC_BC_PACKET_RX_ID_3 							0x01

#define DEDITEC_BC_PACKET_CMD_GLOBAL_CALL					0x01
#define DEDITEC_BC_PACKET_CMD_PARAM_GET						0x02
#define DEDITEC_BC_PACKET_CMD_PARAM_SET						0x03
#define DEDITEC_BC_PACKET_CMD_ETH0_CONFIGURE				0x04

#define DEDITEC_BC_PACKET_PARAM_BOARD_NAME					0x01
#define DEDITEC_BC_PACKET_PARAM_IP_ADDR						0x02
#define DEDITEC_BC_PACKET_PARAM_NETMASK						0x03
#define DEDITEC_BC_PACKET_PARAM_STDGATEWAY					0x04
#define DEDITEC_BC_PACKET_PARAM_DNS1						0x05
#define DEDITEC_BC_PACKET_PARAM_DHCP						0x06
#define DEDITEC_BC_PACKET_PARAM_DELIB_MODULE_ID				0x07

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Parameter fr die WEB-Oberflaeche
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

//CONFIG-Seite

// ------------------------------------
// General
#define DEDITEC_PARAM_BOARD_NAME							"board_name"
#define DEDITEC_PARAM_PRODUCT_NAME							"prodcut_name"
#define DEDITEC_PARAM_CUST1_PRODUCT_NAME					"cust1_product_name"
#define DEDITEC_PARAM_ALTERNATE_INDEX						"config-http-index"
#define DEDITEC_PARAM_PRODUCT_DELIB_MODULE_ID				"product_delib_module_id"

// ------------------------------------
//PRODUCT_CONFIGURATION
#define DEDITEC_PARAM_PRODUCT_CONFIG_DI						"product_cfg_di"
#define DEDITEC_PARAM_PRODUCT_CONFIG_DO						"product_cfg_do"
#define DEDITEC_PARAM_PRODUCT_CONFIG_DI_CNT					"product_cfg_di_cnt"
#define DEDITEC_PARAM_PRODUCT_CONFIG_AI						"product_cfg_ai"
#define DEDITEC_PARAM_PRODUCT_CONFIG_AO						"product_cfg_ao"
#define DEDITEC_PARAM_PRODUCT_CONFIG_TEMP					"product_cfg_temp"
#define DEDITEC_PARAM_PRODUCT_CONFIG_STEPP					"product_cfg_stepp"
#define DEDITEC_PARAM_PRODUCT_CONFIG_CNT48					"product_cfg_cnt48"
#define DEDITEC_PARAM_PRODUCT_CONFIG_PULSEGEN				"product_cfg_pulsegen"
#define DEDITEC_PARAM_PRODUCT_CONFIG_PWM					"product_cfg_pwm"			// 8 Bit

// ------------------------------------
// FW-Revisions
#define DEDITEC_PARAM_FW_REV_KEY							"fw_rev_key_handler"
#define DEDITEC_PARAM_FW_REV_ROETHFW						"fw_rev_ro_eth_fw"
#define DEDITEC_PARAM_FW_REV_BCSERVER						"fw_rev_bc_server"
#define DEDITEC_PARAM_FW_REV_WEBCMD							"fw_rev_webcmd"
#define DEDITEC_PARAM_FW_REV_WEBDAPIEXECUTE					"fw_rev_webdapiexecute"
#define DEDITEC_PARAM_FW_REV_WEBLOGACCESS					"fw_rev_weblogaccess"
#define DEDITEC_PARAM_FW_REV_NTPSERVER						"fw_rev_ntp_server"
#define DEDITEC_PARAM_FW_REV_PARAMSERVER					"fw_rev_parameter_server"
#define DEDITEC_PARAM_FW_REV_ROETHMON						"fw_rev_ro_eth_mon"
#define DEDITEC_PARAM_FW_REV_WEBREQUEST						"fw_rev_parameter_webrequest"
#define DEDITEC_PARAM_FW_REV_USERMGR						"fw_rev_user_manager"
#define DEDITEC_PARAM_FW_REV_CUSTOM1						"cust1_fw_rev"
#define DEDITEC_PARAM_FW_REV_SMSSRV							"fw_rev_sms_srv"
#define DEDITEC_PARAM_FW_REV_EXECSRV						"fw_rev_exec_srv"
#define DEDITEC_PARAM_FW_REV_SCHEDULER						"fw_rev_scheduler"

// ------------------------------------
// Network
#define DEDITEC_PARAM_IP_IP									"config-ip-ip"
#define DEDITEC_PARAM_IP_NETMASK							"config-ip-netmask"
#define DEDITEC_PARAM_IP_STDGATEWAY							"config-ip-stdgateway"
#define DEDITEC_PARAM_IP_DNS1								"config-ip-dns1"

// ------------------------------------
// NTP
#define DEDITEC_PARAM_NTP_ACTIVE							"config-ntp-active"
#define DEDITEC_PARAM_NTP_IP								"config-ntp-ip"
#define DEDITEC_PARAM_NTP_PORT								"config-ntp-port"
#define DEDITEC_PARAM_NTP_TIMEZONE_ACTIVE					"config-ntp-timezone-active"
#define DEDITEC_PARAM_NTP_TIMEZONE_HOUR						"config-ntp-timezone-hour"

// ------------------------------------
// Mail-Server
#define DEDITEC_PARAM_MAIL_SMTP_SERVER_HOSTNAME				"mail-smtp-server-hostname"
#define DEDITEC_PARAM_MAIL_SMTP_SERVER_AUTHENTIFICATE		"mail-smtp-server-authentificate"
#define DEDITEC_PARAM_MAIL_SMTP_SERVER_AUTHENTIFICATE_USER	"mail-smtp-server-authentificate-user"
#define DEDITEC_PARAM_MAIL_SMTP_SERVER_AUTHENTIFICATE_PWD	"mail-smtp-server-authentificate-pwd"

// ------------------------------------
// a number will be appended to each string
//#define DEDITEC_PARAM_MAIL_SENDER							"mail-sender-"
#define DEDITEC_PARAM_MAIL_SENDER_NAME						"mail-sender-name-"
#define DEDITEC_PARAM_MAIL_RECIPIENT						"mail-recipient-"
#define DEDITEC_PARAM_MAIL_SUBJECT							"mail-subject-"
#define DEDITEC_PARAM_MAIL_MESSAGE							"mail-message-"


// ------------------------------------
//MONITORING-Seite

// GSM-Modem
#define DEDITEC_PARAM_GSMMODEM_PINCODE						"gsmmodem_pin_code"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// Default Values for handler_for_ip_set_to_default
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DEFAULT_IP											"192.168.1.1"
#define DEFAULT_NETMASK										"255.255.255.0"
#define DEFAULT_STDGATEWAY									"192.168.1.254"


// ------------------------------------
// Filenames fuer MSGQ
#define DT_MSGQ_PARAM										"/tmp/msgq_param_srv"
#define DT_MSGQ_RO_ETH_FW									"/tmp/msgq_eth-fw-srv"
#define DT_MSGQ_RO_ETH_MON									"/tmp/msgq_eth-mon-srv"
#define DT_MSGQ_USER_MGR									"/tmp/msgq_user_mgr"
#define DT_MSGQ_BC_SRV										"/tmp/msgq_bc-srv"
#define DT_MSGQ_SMS_SRV										"/tmp/msgq_sms-srv"
#define DT_MSGQ_EXEC_SRV									"/tmp/msgq_exec-srv"
//
#define DT_MSGQ_RO_ETH_M2M									"/tmp/msgq_eth-m2m-srv"



// ------------------------------------
// Nummern fuer webrequest
#define DT_SRV_ID_PARAM										1
#define DT_SRV_ID_RO_ETH_FW									2
#define DT_SRV_ID_RO_ETH_MON								3
#define DT_SRV_ID_USER_MGR									4
#define DT_SRV_ID_BC_SRV									5
#define DT_SRV_ID_SMS_SRV									6
#define DT_SRV_ID_EXEC_SRV									9
//
#define DT_SRV_ID_RO_ETH_M2M								100


// ------------------------------------
// Namen fuer die Server / z.B. Logbuch - Antwort fuer "?"
#define DT_SRV_NAME_SCHEDULER								"Scheduler"
//
#define DT_SRV_NAME_PARAM									"Param-Srv"
#define DT_SRV_NAME_RO_ETH_FW								"RO-ETH-FW"
#define DT_SRV_NAME_RO_ETH_MON								"RO-ETH-Mon"
#define DT_SRV_NAME_USER_MGR								"User-Mgr-Srv"
#define DT_SRV_NAME_BC_SRV									"BC-Srv"
#define DT_SRV_NAME_SMS_SRV									"SMS-Srv"
#define DT_SRV_NAME_EXEC_SRV								"Exec-Srv"
//
#define DT_SRV_NAME_RO_ETH_M2M								"RO-ETH-M2M"

// ------------------------------------
// Namen fuer die Programme / z.B. Logbuch

#define DT_PROG_NAME_WEBREQUEST								"webrequest"
#define DT_PROG_NAME_WEBLOGACCESS							"WEB-log-access"
#define DT_PROG_NAME_HTTPD_CONF_SET							"HTTPD-Conf-Set"
#define DT_PROG_NAME_IP_ADDR_SET							"ip_adress_set"
#define DT_PROG_NAME_KEY_HANDLER							"KEY_Handler"
#define DT_PROG_NAME_NTP_CLIENT								"NTP-Client"
#define DT_PROG_NAME_SENDMAIL								"Sendmail"
#define DT_PROG_NAME_WEBFWUPLOAD							"WEBFWUPLOAD"
#define DT_PROG_NAME_WEBLOGIN								"WEBLOGIN"
#define DT_PROG_NAME_WEBCMD									"WEBCMD"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// User Manager
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------

#define DT_USERMGR_SESSION_COUNT							50
#define DT_USERMGR_SESSION_TIME_DEFAULT						200
#define DT_USERMGR_SESSION_TIME_NAME						"config-usr-mgr-session-valid-time"

#define DT_USERMGR_MSGQ_ERROR								100

#define DT_USERMGR_PERMISSION_GRANTED						0
#define DT_USERMGR_PERMISSION_DENIED						1
#define DT_USERMGR_SESSION_EXPIRED							2

#define DT_USERMGR_LOGIN_SUCCESS							0
#define DT_USERMGR_LOGIN_FAILED								1
#define DT_USERMGR_SESSION_OVERFLOW							2
#define DT_USERMGR_COOKIE_SEED_ISSUE						3


#define DT_USERMGR_RIGHTS_ALL_NAME							"config-usr-mgr-rights-list"
#define DT_USERMGR_RIGHTS_ALL								"io_ro,io_rw,config_ro,config_rw,monitor_ro,monitor_rw,usermgr_ro,usermgr_rw"

#define DT_USERMGR_RIGHTS_WEB_IO_RO							"io_ro"
#define DT_USERMGR_RIGHTS_WEB_IO_RW							"io_rw"
#define DT_USERMGR_RIGHTS_WEB_CONFIG_RO						"config_ro"
#define DT_USERMGR_RIGHTS_WEB_CONFIG_RW						"config_rw"
#define DT_USERMGR_RIGHTS_WEB_MON_RO						"monitor_ro"
#define DT_USERMGR_RIGHTS_WEB_MON_RW						"monitor_rw"
#define DT_USERMGR_RIGHTS_WEB_USER_RO						"usermgr_ro"
#define DT_USERMGR_RIGHTS_WEB_USER_RW						"usermgr_rw"

// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
// END
// ----------------------------------------------------------------------------
// ----------------------------------------------------------------------------
